import java.awt.*;
import java.awt.event.*;

import javax.swing.JFrame;

public class MouseEventWinEx03 extends JFrame {
	private static final long serialVersionUID = 1L;

	MouseEventWinEx03 childWin;
	static int countChild;
	
	public MouseEventWinEx03() {		
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(300, 130);
		setVisible(true);
		
		//register mouse event handler, motion event handler
		addMouseListener(new myMouseAdapter());		 
		addMouseMotionListener(new myMouseMotionAdapter());		
	}
	
	class myMouseAdapter extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
			Rectangle bounds = getBounds();
			int x = e.getX() + bounds.x;
			int y = e.getY() + bounds.y;
			
			childWin = new MouseEventWinEx03();
			childWin.setLocation(x, y);
			childWin.setTitle(++countChild + "'th child window");
			childWin.setSize(getSize().width/2, getSize().height/2);
			childWin.setVisible(true);    
		}
		public void mouseReleased(MouseEvent e) {
			if (childWin != null) childWin.setVisible(false);    
		}
	}
	
	class myMouseMotionAdapter extends MouseMotionAdapter {
		public void mouseDragged(MouseEvent e) {
			Rectangle bounds = getBounds();
			int x = e.getX() + bounds.x;
			int y = e.getY() + bounds.y;
			if (childWin != null) {
				childWin.setLocation(x, y);
				childWin.setVisible(true);    
			}
		}
	}
	
	public static void main(String [] args) {
		MouseEventWinEx03 myWin = new MouseEventWinEx03();
		myWin.setTitle("Frame Window");		
	}
}
